/***************************************************************************
                          kmmsprefsImpl.cpp  -  description
                             -------------------
    begin                : Wed Mar 07 2001
    copyright            : (C) 2001 by Janosch Rolles
    email                : janosch@base2.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "kmmsprefsImpl.h"


/* constructor */
kmmsprefsImpl::kmmsprefsImpl( QWidget* parent, const char* name, bool modal, WFlags f ) :
    kmmsprefs( parent, name, modal, f )
{

}

bool kmmsprefsImpl::getPrefs(QColor* titleColor, QColor* osdColor, bool* clearPlaylistOnDrop, bool* autoPlayAddedSongs)
{
	saveChanges = false;
	// make passed pointers available in the whole class
	titleColorPt					= titleColor;
	osdColorPt						= osdColor;
  clearPlaylistOnDropPt	= clearPlaylistOnDrop;
	autoPlayAddedSongsPt	= autoPlayAddedSongs;
	// backup values
	backupValues();
	// set starting values in widget
	initializeWidget();
  // execute dialog (let the user make changes)
  if ( exec() == 1) {
    // if user accepted values -> get the not automatically updated ones
    askWidget();
  }	else {
		// if user canceled restore the old values
		restoreValues();
	}
	return saveChanges;
}

void kmmsprefsImpl::backupValues()
{
	// lets also backup the not automatically changed (saver for future, less complicated)
	titleColorBak						= *titleColorPt;
	osdColorBak							= *osdColorPt;
  clearPlaylistOnDropBak	= *clearPlaylistOnDropPt;
	autoPlayAddedSongsBak		= *autoPlayAddedSongsPt;
}

void kmmsprefsImpl::restoreValues()
{
	*titleColorPt						= titleColorBak;
	*osdColorPt							= osdColorBak;
  *clearPlaylistOnDropPt	= clearPlaylistOnDropBak;
	*autoPlayAddedSongsPt		= autoPlayAddedSongsBak;
}

void kmmsprefsImpl::initializeWidget()
{
	titleColorButton->setColor( *titleColorPt );
	osdColorButton->setColor( *osdColorPt );

	clearPlaylistOnDropCheckBox->setChecked(*clearPlaylistOnDropPt);
	autoPlayAddedSongsCheckBox->setChecked(*autoPlayAddedSongsPt);
}

void kmmsprefsImpl::askWidget( )
{
	// get values - just the not automatically updated ones (and store them through the pointers)
	*clearPlaylistOnDropPt	= clearPlaylistOnDropCheckBox->isChecked();
	*autoPlayAddedSongsPt 	= autoPlayAddedSongsCheckBox->isChecked();

	// save the values to config file?
	saveChanges = saveChangesCheckBox->isChecked();
}

void kmmsprefsImpl::titleColorButtonImpl(const QColor& color)
{
	// store value though pointer
	*titleColorPt = color;
}

void kmmsprefsImpl::osdColorButtonImpl(const QColor& color)
{
	// store value though pointer
	*osdColorPt = color;
}



